(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: eval_top.mli,v 1.2 2003/05/28 14:47:38 simeon Exp $ *)

(* Module Eval_top
   Description:
     This module implements evaluation of top-level statements and of
     the XQuery prolog.
*)

val eval_cstatement :
    Dynamic_context.dynamic_context  -> Xquery_ast.cstatement -> Datamodel._Value
    (* Evaluate a top level statement *)

val eval_query :
    Dynamic_context.dynamic_context  -> Xquery_ast.cquery_module -> (Datamodel._Value) list
    (* Evaluate the whole query *)

val eval_toplevel :
    Dynamic_context.dynamic_context -> Xquery_ast.cquery_module -> Dynamic_context.dynamic_context 
    (* Evaluate global declarations *)

