(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: fn_error.mli,v 1.1 2003/05/01 20:02:07 simeon Exp $ *)

(* Module Fn_error
   Description:
     This module implements support for the user-level fn:error()
     function.
*)

type xquery_error_msg =
  | Empty_Error
  | Error_Item of Datamodel._Value

exception Xquery_error of xquery_error_msg

val raise_empty_error : unit -> 'a

val raise_item_error : Datamodel._Value -> 'a

val downgrade_error : xquery_error_msg -> 'a

