(* $Id: pxp_lib.mli,v 1.1 2003/02/10 05:04:11 simeon Exp $
 * ----------------------------------------------------------------------
 * PXP: The polymorphic XML parser for Objective Caml.
 * Copyright by Gerd Stolpmann. See LICENSE for details.
 *)

(* This module contains special versions of library functions which
 * have been optimized for various data and runtime cases.
 *)

val crlf_index_from : string -> int -> int
    (* Returns the leftmost position >= i in the string of either a CR or a
     * LF character.
     * Returns -1 if there is no such character.
     *)

val only_whitespace : string -> bool
    (* Returns true if the string consists only of whitespace characters
     * (space, tab, CR, LF)
     *)

(* ======================================================================
 * History:
 *
 * $Log: pxp_lib.mli,v $
 * Revision 1.1  2003/02/10 05:04:11  simeon
 * February 10, 2003 - Jerome
 *
 *   - Support for all kinds of character encodings on the input. Hooked
 *     up Galax's XML lexers to PXP's resolvers. This takes care of
 *     reading a large numbers of characters encodings, including UTF-16,
 *     various ISO formats, etc. See PXP's documentation for more
 *     details.
 *
 *   - Serious cleanup and improvement of the SAX parser:
 *      o Fixed bug in lexing of UTF-8 characters, now accessed properly
 *        from the lexing buffer.
 *      o Fixed SAX parser to keep track of the parsing location when an
 *        error occurs, and print errors according to the file currently
 *        being processed.
 *
 * Revision 1.1  2000/10/01 19:50:29  gerd
 * 	Initial revision.
 *
 *)
