(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: serialization.mli,v 1.2 2003/06/21 15:30:55 simeon Exp $ *)

(* Module: Serialization
   Description:
     This module supports serialization of XML values either from the
     XML Query data model or directly from an XML
     stream. Serialization can occur directly on any given output
     formatter. (See the OCaml Format library).
*)

(* Serialization from an XML stream *)

val fserialize_xml_stream : Format.formatter -> Sax_types.xml_stream -> unit

val serialize_xml_stream  : Sax_types.xml_stream -> unit
val bserialize_xml_stream : Sax_types.xml_stream -> string

(* Serialization from an XML data model *)

val fserialize_datamodel  : Format.formatter -> Datamodel._Value -> unit

val serialize_datamodel   : Datamodel._Value -> unit
val bserialize_datamodel  : Datamodel._Value -> string

