(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: stream_ops.mli,v 1.2 2003/06/09 15:28:27 simeon Exp $ *)

(* Module: Stream_ops
   Description:
     Some basic operations on XML streams.
*)

val discard_xml_stream                     : Sax_types.xml_stream -> unit
    (* Discards the current XML subtree *)

val discard_xml_stream_remember_namespaces : Sax_types.xml_stream -> unit
    (* Discards the current XML subtree, but remembers updating the namespace environment *)

val untype_xml_stream : Sax_types.typed_xml_stream -> Sax_types.xml_stream
    (* Turns a typed XML stream into an untyped one *)

