(***********************************************************************)
(*                                                                     *)
(*                               Galax                                 *)
(*                            XQuery Engine                            *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: toputils.mli,v 1.25 2003/05/21 15:03:49 simeon Exp $ *)

(**********************)
(* Printing functions *)
(**********************)

val separator : string ref

val fprint_query_env : Format.formatter -> Xquery_ast.cquery_module -> unit

(*********************)
(* Loading functions *)
(*********************)

(* Loading library *)

val load_pervasive : unit -> Xquery_ast.query_module

(*********)
(* Setup *)
(*********)

val setup : int -> int -> unit

(*********************)
(* Schema operations *)
(*********************)

val convert_schema : string -> Namespace.prefix -> (Namespace.nsenv * Xquery_ast.sort_decl list)

val convert_xquery_context : string -> (Namespace.nsenv * Xquery_ast.sort_decl list)

val load_schema : (Namespace.nsenv * Xquery_ast.sort_decl list) -> Schema.schema

val print_schema_types : Format.formatter -> Xquery_ast.sort_decl list -> unit

