{-- ---------------------------------------
       Use Case "Tree" : Operations on trees
     --------------------------------------- --}

define element book { 
  element title, 
  element author+, 
  element section+ 
}
define element title { xsd:string }
define element author { xsd:string } 

define element section { 
  attribute ID { xsd:string }?,
  attribute difficulty { xsd:string }?,
  element title, 
  (element p | element figure | element section)* 
}

define element p { xsd:string }

define element figure { 
  attribute height { xsd:string },
  attribute width  { xsd:string },
  element title, 
  element image 
} 

define element image { 
  attribute source { xsd:string }
}

define element section_summary { 
  attribute ID { xsd:string }?,
  attribute difficulty { xsd:string }?,
  element title, 
  element figcount { xsd:int }, 
  element section_summary*
}

define global $book1 { treat as document book (glx:document-validate("docs/book1.xml", "book")) }

define function toc($book-or-section as element) as element*
{
   for $section in $book-or-section/section
   return 
       <section>
       { $section/@*, $section/title, toc($section) }
       </section>
}

define function section-summary($book-or-section as element) as element*
{
  for $section in $book-or-section/section
  return
    <section>
       { $section/@* }
       { $section/title }   
       <figcount>     
         { count($section/figure) }
       </figcount>        
       { section-summary($section) }            
    </section>
}


